/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	"sotel.h"

char  TermInBuff[TERMBUFF_SIZE + 1];
char  TermOutBuff[TERMBUFF_SIZE + 1];
TCHAR tTermOutBuff[TERMBUFF_SIZE + 1];
int   termin_pos;
int   termout_pos;

void terminit()
{
	/* TELNET̏ */
	telnet_state  = ST_DATA;
	bTelnet       = FALSE;
	iCmdSent      = WILL_TERMTYPE|DO_SUP_GA|WILL_SUP_GA|DO_ECHO|WONT_ECHO|WILL_NAWS;
	bEchoOn       = TRUE;
	iChkAuthByte  = 0;
	/* ^[~ȉ */
	termin_pos    = 0;
	termout_pos   = 0;
	/* R[hϊ̏ */
	conv_state    = CHARDATA;
	iKcode        = 0;
	return;
}

void termset(char *buf, int len)
{
	if (termout_pos > (TERMBUFF_SIZE - len)){
		termpush();
	}
	memcpy(TermOutBuff + termout_pos, buf, len);
	termout_pos += len;
	return;
}

int termin()
{
	char keyin[KEYBUFF_SIZE];
	char *p = keyin;
	int len;

	len = CgetsVT(keyin, KEYBUFF_SIZE);

	/* GXP[v */
	if (len > 0 && keyin[0] == 0x1d)
		len = -1;

	if (len > 0){
		/* ̓obt@փRs[ */
		if ((termin_pos + len) <= TERMBUFF_SIZE){
			memcpy(TermInBuff + termin_pos, keyin, len);
			termin_pos += len;
		}
		/* [JGR[ */
		if (bEchoOn){
			while (len){
				if (*p) termset(p, 1);
				len--;
				p++;
			}
			if (keyin[0] == '\r' || keyin[0] == '\n'){
				len = termin_pos;
			} else {
				len = 0;
			}
		}
	}

	return len;
}

void termout(unsigned char c)
{
	char sjis[3];
	char *p = sjis;
	int len;

	len = j10nc(sjis, &iKcode, c);

	while (len){
		/* NULL͏o͂Ȃ */
		if (*p) termset(p, 1);
		p++;
		len--;
	}
}

void termpush()
{
	unsigned char *src = TermOutBuff;
	TCHAR *dst = tTermOutBuff;

	if (termout_pos){
		WriteLog(src, termout_pos);
		src[termout_pos] = 0;
		while (*src){
			TCHAR c = (TCHAR)*src++;
			*dst++  = c;
		}
		*dst = TEXT('\0');
		CputsVT(tTermOutBuff);
		termout_pos = 0;
	}
	return;
}
